15 =>  int numSpaces;

//0 = right, 1 = down, 2 = left, 3 = up
1.0 => global float moveInc;

public class Player1 extends GGen {
    0 => int lastDir;
    1.3 => float sizePlayer;

    GPlane player --> GG.scene();
    
    FlatMaterial mat;
    FileTexture texture;
    texture.path("p2.png");
    texture.wrap(1, 1);
    mat.diffuseMap(texture);
    mat.transparent(1);
    player.mat(mat);

    FlatMaterial matHurt;
    FileTexture textureHurt;
    textureHurt.path("p2hurt.png");
    textureHurt.wrap(1, 1);
    matHurt.diffuseMap(textureHurt);
    matHurt.transparent(1);

    player.posX(moveInc / 2) => float currX; //initial x setting
    player.posY(moveInc / 2) => float currY; //initial y setting
    player.sca(sizePlayer);

    player.posX(7.5);
    player.posY(7.5);
    player.posZ(0.03);

    -1 => int lastFood;

    fun void ate(int type) {
        // Food currFood --> player;
        type => lastFood;
    }

    fun int isAt(float x, float y) {
        if (player.posX() == x && player.posY() == y) return 1;
        return 0;
    }

    fun int isAtY(float y) {
        if (player.posX() == y) return 1;
        return 0;
    }

    fun string posAsKey() {
        return player.posX() + " " + player.posY();
    }

    fun int getDir() {
        return lastDir;
    }

    fun void isHurt() {
        player.mat(matHurt);
    }

    fun void isFine() {
        player.mat(mat);
    }

    fun void update( float dt ) {
        player.posX() => currX;
        player.posY() => currY;

        /* * * * *
         * COLLISION at edge of board
         * * * * */
        if (currX >= 14.5 || currY >= 14.5 || currX <= 0.5 || currY <= 0.5) {
            //0 = right, 1 = down, 2 = left, 3 = up
            if (lastDir == 0) { //reverse direction
                2 => lastDir;
            } else if (lastDir == 2) {
                0 => lastDir;
            } else if (lastDir == 1) {
                3 => lastDir;
            } else if (lastDir == 3) {
                1 => lastDir;
            }
            move();
        } else {
            detectKB();
        }
    } //end of update func

    fun void move() { //moves the player!
        /* * * * *
        * MOVEMENT!
        * * * * */
        if (lastDir == 0) {
            player.posX(moveInc + currX);
            player.posX() => currX;
        } else if (lastDir == 1) {
            player.posY(-1 * moveInc + currY);
            player.posY() => currY;
        } else if (lastDir == 2) {
            player.posX(-1 * moveInc + currX);
            player.posX() => currX;
        } else if (lastDir == 3) {
            player.posY(moveInc + currY);
            player.posY() => currY;
        }
    } //end of move

    fun void detectKB() {
        if( KB.isKeyDown(KB.KEY_D) ) { //right
            player.posX(moveInc + currX);
            player.posX() => currX;
            0 => lastDir;
            return;
        } else if( KB.isKeyDown(KB.KEY_S) ) { //down
            player.posY(-1 * moveInc + currY);
            player.posY() => currY;
            1 => lastDir;
            return;
        } else if( KB.isKeyDown(KB.KEY_A) ) { //left
            player.posX(-1 * moveInc + currX);
            player.posX() => currX;
            2 => lastDir;
            return;
        } else if( KB.isKeyDown(KB.KEY_W) ) { //up
            player.posY(moveInc + currY);
            player.posY() => currY;
            3 => lastDir;
            return;
        }
        move();
    }
}