1.0 => global float sizeBoard;
15 => global int numSpaces;
3 => global int numInstruments;

sizeBoard / 2 => global float initX;
sizeBoard / 2 => global float initY;
1.5 => global float scaFactor;
0 => global int pulseOn;

public class Board extends GGen {
    -1 => int lastFood;
    0 => int playheadCol;

    FlatMaterial matSpace;
    FileTexture texture;
    texture.path("space.png");
    texture.wrap(1, 1);
    matSpace.diffuseMap(texture);

    FlatMaterial matSpace1;
    FileTexture textureSpace1;
    textureSpace1.path("space1.png");
    textureSpace1.wrap(1, 1);
    matSpace1.diffuseMap(textureSpace1);

    FlatMaterial matSpace2;
    FileTexture textureSpace2;
    textureSpace2.path("space2.png");
    textureSpace2.wrap(1, 1);
    matSpace2.diffuseMap(textureSpace2);

    FlatMaterial matSpace3;
    FileTexture textureSpace3;
    textureSpace3.path("space3.png");
    textureSpace3.wrap(1, 1);
    matSpace3.diffuseMap(textureSpace3);



    FlatMaterial matPlayhead;
    FileTexture texturePH;
    texturePH.path("space_selected.png");
    texturePH.wrap(1, 1);
    matPlayhead.diffuseMap(texturePH);

    FileTexture texturePH2;
    texturePH2.path("space_selected2.png");
    texturePH2.wrap(1, 1);

    FlatMaterial matPlayheadA;
    FileTexture texturePHA;
    texturePHA.path("space_selected2_angry.png");
    texturePHA.wrap(1, 1);
    matPlayheadA.diffuseMap(texturePHA);
    
    FileTexture texturePHA2;
    texturePHA2.path("space_selected_angry.png");
    texturePHA2.wrap(1, 1);


    FileTexture textureFood3;
    textureFood3.path("food3.png");
    textureFood3.wrap(1, 1);
    FlatMaterial matFood;
    matFood.diffuseMap(textureFood3);
    matFood.transparent(1);
    
    GPlane spaces[numSpaces * numSpaces];
    GPlane food[numSpaces * numSpaces]; //0 if none, other numbers indicate what type of food
    int foodType[numSpaces * numSpaces]; //converts "x y" coord string to an index for use in spaces and food arrays
    int coordsToInd[numSpaces * numSpaces]; //converts "x y" coord string to an index for use in spaces and food arrays
    float rowToY[numSpaces];
    float colToX[numSpaces];
    int inst0[numSpaces * 5];
    int inst1[numSpaces * 5];
    int inst2[numSpaces * 5];

    int angry[3];

    initY => float currY;
    0 => int inst0Ind;
    0 => int inst1Ind;
    0 => int inst2Ind;
    for (0 => int i; i < numSpaces; i++) { //set up the board
        initX => float currX;
        for (0 => int j; j < numSpaces; j++) { //col
            spaces[i * numSpaces + j] --> GPlane space;
            space --> this;
            space.sca(sizeBoard);
            space.posX((currX + j * sizeBoard));
            space.posY((currY + i * sizeBoard));
            space.posZ(0);
            i / (numSpaces / numInstruments) => int instrument;
            if (instrument == 0) {
                space.mat(matSpace3);
                i * numSpaces + j => inst0[inst0Ind];
                inst0Ind++;
            } else if (instrument == 1) {
                space.mat(matSpace2);
                i * numSpaces + j => inst1[inst1Ind];
                inst1Ind++;
            } else if (instrument == 2) {
                space.mat(matSpace1);
                i * numSpaces + j => inst2[inst2Ind];
                inst2Ind++;
            }

            0 => foodType[i * numSpaces + j];

            //used to get the mapping from location to index
            "" + (currX + j * sizeBoard) => string x;
            "" + (currY + i * sizeBoard) => string y;
            x + " " + y => string coordKey;
            i * numSpaces + j => coordsToInd[coordKey];

            currX + j * sizeBoard => colToX[j];
        }
        currY + i * sizeBoard => rowToY[i];
    }

    fun int getIndex(string key) {
        return coordsToInd[key];
    }

    fun float getX(int col) {
        return colToX[col];
    }

    fun float getY(int row) {
        return rowToY[row];
    }

    fun int getFoodType(int ind) {
        return foodType[ind];
    }

    //layer a pellet on top of the board location
    fun void placeFood(int ind, int type) {
        type => foodType[ind];
        food[ind].mat(matFood);

        getX(ind % numSpaces) => float foodX;
        getY(ind / numSpaces) => float foodY;
        
        food[ind].posX(foodX);
        food[ind].posY(foodY);
        food[ind].posZ(0.03);
        food[ind].sca(0.5);
        food[ind] --> this;
    }

    fun int hasFood(int ind) {
        if (foodType[ind] > 0) return 1;
        return 0;
    }

    fun void removeFood(int ind) {
        if (foodType[ind] > 0) {
            0 => foodType[ind];
            food[ind] --< this; //ungruck!
        }
    }

    //updates the playhead! it gets "angry" if there are no pellets in any section
    fun void update( float dt ) {
        resetColors();
        for (0 => int i; i < numSpaces; i++) {

            //do it here
            ((playheadCol + i * numSpaces) / numSpaces) / (numSpaces / numInstruments) => int instrument;
            // <<< (playheadCol + i * numSpaces) + ": " + instrument>>>;
            if (angry[0] == 1 || angry[1] == 1 || angry[2] == 1) {
                // spaces[playheadCol + i * numSpaces].mat(matPlayhead);
                texturePH.path("space_selected2_angry.png");
                texturePH2.path("space_selected_angry.png");
            } else {
                texturePH.path("space_selected2.png");
                texturePH2.path("space_selected.png");
            }
            spaces[playheadCol + i * numSpaces].mat(matPlayhead);


            spaces[playheadCol + i * numSpaces].posZ(0.02);
            setColor(spaces[playheadCol + i * numSpaces]);
        }
    }

    fun void foodPlayheadAnim(GPlane currFood) {
        currFood.scaX()  + .05 * (1.0 - currFood.scaX()) => currFood.sca;
    }

    fun void setPlayhead(int col) {
        col => playheadCol;
    }

    fun int[] playheadToInds(int playhead) {
        int inds[numSpaces];
        for (0 => int i; i < numSpaces; i++) {
            playhead + i * numSpaces => inds[i];
        }
        return inds;
    }

    fun int[] findFoodInArea(int area) {
        int currArea[];
        if (area == 0) {
            inst0 @=> currArea;
        } else if (area == 1) {
            inst1 @=> currArea;
        } else if (area == 2) {
            inst2 @=> currArea;
        }

        int foodLoc[numSpaces * 5];
        int locInd;

        for (0 => int i; i < numSpaces * 5; i++) {
            if (hasFood(currArea[i])) {
                currArea[i] => foodLoc[locInd]; //index location of food collected in foodLoc
                locInd++;
            }
        }
        return foodLoc;
    }

    fun void setColor(GPlane currSpace) {
        currSpace.mat(matPlayhead);
    }

    fun void resetColors() {
        for (0 => int i; i < numSpaces * numSpaces; i++) {
            spaces[i].mat(matSpace);
        }
    }

    fun void isAngry(int instr, int isAngry) {
        isAngry => angry[instr];
    }

    fun void playheadAnim(int round) {
        if (round % 2 == 0) {
            matPlayhead.diffuseMap(texturePH);
        } else {
            matPlayhead.diffuseMap(texturePH2);
        }
    }

    //gets the position of an indicated space.
    //both row and column are 1-indexed in this case.
    fun float[] getPosOfSpace(int row, int col) {
        spaces[row * numSpaces + col] --> GPlane space;
        return [space.posX(), space.posY()];
    }

    //gets the space at the indicated row, column.
    //both row and column are 1-indexed in this case.
    fun GPlane getSpace(int row, int col) {
        return spaces[row * numSpaces + col];
    }
}